// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/InterferenceIndicator.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__INTERFERENCE_INDICATOR__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__INTERFERENCE_INDICATOR__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__InterferenceIndicator __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__InterferenceIndicator __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct InterferenceIndicator_
{
  using Type = InterferenceIndicator_<ContainerAllocator>;

  explicit InterferenceIndicator_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->fov_reduction_due_to_interfence = 0.0f;
      this->interference_indicator = 0;
    }
  }

  explicit InterferenceIndicator_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->fov_reduction_due_to_interfence = 0.0f;
      this->interference_indicator = 0;
    }
  }

  // field types and members
  using _fov_reduction_due_to_interfence_type =
    float;
  _fov_reduction_due_to_interfence_type fov_reduction_due_to_interfence;
  using _interference_indicator_type =
    uint8_t;
  _interference_indicator_type interference_indicator;

  // setters for named parameter idiom
  Type & set__fov_reduction_due_to_interfence(
    const float & _arg)
  {
    this->fov_reduction_due_to_interfence = _arg;
    return *this;
  }
  Type & set__interference_indicator(
    const uint8_t & _arg)
  {
    this->interference_indicator = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t INVALID_INTERFERENCE =
    0u;
  static constexpr uint8_t VALID_NO_INTERFERENCE =
    1u;
  static constexpr uint8_t VALID_INTERFERENCE =
    2u;

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__InterferenceIndicator
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__InterferenceIndicator
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const InterferenceIndicator_ & other) const
  {
    if (this->fov_reduction_due_to_interfence != other.fov_reduction_due_to_interfence) {
      return false;
    }
    if (this->interference_indicator != other.interference_indicator) {
      return false;
    }
    return true;
  }
  bool operator!=(const InterferenceIndicator_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct InterferenceIndicator_

// alias to use template instance with default allocator
using InterferenceIndicator =
  off_highway_premium_radar_sample_msgs::msg::InterferenceIndicator_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t InterferenceIndicator_<ContainerAllocator>::INVALID_INTERFERENCE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t InterferenceIndicator_<ContainerAllocator>::VALID_NO_INTERFERENCE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t InterferenceIndicator_<ContainerAllocator>::VALID_INTERFERENCE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__INTERFERENCE_INDICATOR__STRUCT_HPP_
