// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/MisalignmentPacket.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__MISALIGNMENT_PACKET__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__MISALIGNMENT_PACKET__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MisalignmentPacket_
{
  using Type = MisalignmentPacket_<ContainerAllocator>;

  explicit MisalignmentPacket_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->theta = 0.0f;
      this->theta_variance = 0.0f;
      this->phi = 0.0f;
      this->phi_variance = 0.0f;
      this->phi_eme = 0.0f;
      this->phi_eme_variance = 0.0f;
      this->status = 0;
      this->status_eme = 0;
      this->percent_negative_theta = 0.0f;
      this->min_theta_sos = 0.0f;
      this->max_theta_sos = 0.0f;
      this->theta_sos_variance = 0.0f;
      this->theta_sos_mean = 0.0f;
      this->min_phi_sos = 0.0f;
      this->max_phi_sos = 0.0f;
      this->phi_sos_variance = 0.0f;
      this->phi_sos_mean = 0.0f;
      this->phi_sos_spread = 0.0f;
      this->num_sos = 0;
      this->num_eme = 0;
    }
  }

  explicit MisalignmentPacket_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->theta = 0.0f;
      this->theta_variance = 0.0f;
      this->phi = 0.0f;
      this->phi_variance = 0.0f;
      this->phi_eme = 0.0f;
      this->phi_eme_variance = 0.0f;
      this->status = 0;
      this->status_eme = 0;
      this->percent_negative_theta = 0.0f;
      this->min_theta_sos = 0.0f;
      this->max_theta_sos = 0.0f;
      this->theta_sos_variance = 0.0f;
      this->theta_sos_mean = 0.0f;
      this->min_phi_sos = 0.0f;
      this->max_phi_sos = 0.0f;
      this->phi_sos_variance = 0.0f;
      this->phi_sos_mean = 0.0f;
      this->phi_sos_spread = 0.0f;
      this->num_sos = 0;
      this->num_eme = 0;
    }
  }

  // field types and members
  using _theta_type =
    float;
  _theta_type theta;
  using _theta_variance_type =
    float;
  _theta_variance_type theta_variance;
  using _phi_type =
    float;
  _phi_type phi;
  using _phi_variance_type =
    float;
  _phi_variance_type phi_variance;
  using _phi_eme_type =
    float;
  _phi_eme_type phi_eme;
  using _phi_eme_variance_type =
    float;
  _phi_eme_variance_type phi_eme_variance;
  using _status_type =
    uint16_t;
  _status_type status;
  using _status_eme_type =
    uint16_t;
  _status_eme_type status_eme;
  using _percent_negative_theta_type =
    float;
  _percent_negative_theta_type percent_negative_theta;
  using _min_theta_sos_type =
    float;
  _min_theta_sos_type min_theta_sos;
  using _max_theta_sos_type =
    float;
  _max_theta_sos_type max_theta_sos;
  using _theta_sos_variance_type =
    float;
  _theta_sos_variance_type theta_sos_variance;
  using _theta_sos_mean_type =
    float;
  _theta_sos_mean_type theta_sos_mean;
  using _min_phi_sos_type =
    float;
  _min_phi_sos_type min_phi_sos;
  using _max_phi_sos_type =
    float;
  _max_phi_sos_type max_phi_sos;
  using _phi_sos_variance_type =
    float;
  _phi_sos_variance_type phi_sos_variance;
  using _phi_sos_mean_type =
    float;
  _phi_sos_mean_type phi_sos_mean;
  using _phi_sos_spread_type =
    float;
  _phi_sos_spread_type phi_sos_spread;
  using _num_sos_type =
    uint16_t;
  _num_sos_type num_sos;
  using _num_eme_type =
    uint16_t;
  _num_eme_type num_eme;

  // setters for named parameter idiom
  Type & set__theta(
    const float & _arg)
  {
    this->theta = _arg;
    return *this;
  }
  Type & set__theta_variance(
    const float & _arg)
  {
    this->theta_variance = _arg;
    return *this;
  }
  Type & set__phi(
    const float & _arg)
  {
    this->phi = _arg;
    return *this;
  }
  Type & set__phi_variance(
    const float & _arg)
  {
    this->phi_variance = _arg;
    return *this;
  }
  Type & set__phi_eme(
    const float & _arg)
  {
    this->phi_eme = _arg;
    return *this;
  }
  Type & set__phi_eme_variance(
    const float & _arg)
  {
    this->phi_eme_variance = _arg;
    return *this;
  }
  Type & set__status(
    const uint16_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__status_eme(
    const uint16_t & _arg)
  {
    this->status_eme = _arg;
    return *this;
  }
  Type & set__percent_negative_theta(
    const float & _arg)
  {
    this->percent_negative_theta = _arg;
    return *this;
  }
  Type & set__min_theta_sos(
    const float & _arg)
  {
    this->min_theta_sos = _arg;
    return *this;
  }
  Type & set__max_theta_sos(
    const float & _arg)
  {
    this->max_theta_sos = _arg;
    return *this;
  }
  Type & set__theta_sos_variance(
    const float & _arg)
  {
    this->theta_sos_variance = _arg;
    return *this;
  }
  Type & set__theta_sos_mean(
    const float & _arg)
  {
    this->theta_sos_mean = _arg;
    return *this;
  }
  Type & set__min_phi_sos(
    const float & _arg)
  {
    this->min_phi_sos = _arg;
    return *this;
  }
  Type & set__max_phi_sos(
    const float & _arg)
  {
    this->max_phi_sos = _arg;
    return *this;
  }
  Type & set__phi_sos_variance(
    const float & _arg)
  {
    this->phi_sos_variance = _arg;
    return *this;
  }
  Type & set__phi_sos_mean(
    const float & _arg)
  {
    this->phi_sos_mean = _arg;
    return *this;
  }
  Type & set__phi_sos_spread(
    const float & _arg)
  {
    this->phi_sos_spread = _arg;
    return *this;
  }
  Type & set__num_sos(
    const uint16_t & _arg)
  {
    this->num_sos = _arg;
    return *this;
  }
  Type & set__num_eme(
    const uint16_t & _arg)
  {
    this->num_eme = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__MisalignmentPacket
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MisalignmentPacket_ & other) const
  {
    if (this->theta != other.theta) {
      return false;
    }
    if (this->theta_variance != other.theta_variance) {
      return false;
    }
    if (this->phi != other.phi) {
      return false;
    }
    if (this->phi_variance != other.phi_variance) {
      return false;
    }
    if (this->phi_eme != other.phi_eme) {
      return false;
    }
    if (this->phi_eme_variance != other.phi_eme_variance) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    if (this->status_eme != other.status_eme) {
      return false;
    }
    if (this->percent_negative_theta != other.percent_negative_theta) {
      return false;
    }
    if (this->min_theta_sos != other.min_theta_sos) {
      return false;
    }
    if (this->max_theta_sos != other.max_theta_sos) {
      return false;
    }
    if (this->theta_sos_variance != other.theta_sos_variance) {
      return false;
    }
    if (this->theta_sos_mean != other.theta_sos_mean) {
      return false;
    }
    if (this->min_phi_sos != other.min_phi_sos) {
      return false;
    }
    if (this->max_phi_sos != other.max_phi_sos) {
      return false;
    }
    if (this->phi_sos_variance != other.phi_sos_variance) {
      return false;
    }
    if (this->phi_sos_mean != other.phi_sos_mean) {
      return false;
    }
    if (this->phi_sos_spread != other.phi_sos_spread) {
      return false;
    }
    if (this->num_sos != other.num_sos) {
      return false;
    }
    if (this->num_eme != other.num_eme) {
      return false;
    }
    return true;
  }
  bool operator!=(const MisalignmentPacket_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MisalignmentPacket_

// alias to use template instance with default allocator
using MisalignmentPacket =
  off_highway_premium_radar_sample_msgs::msg::MisalignmentPacket_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__MISALIGNMENT_PACKET__STRUCT_HPP_
