// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorModulationPerformance.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_MODULATION_PERFORMANCE__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_MODULATION_PERFORMANCE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SensorModulationPerformance_
{
  using Type = SensorModulationPerformance_<ContainerAllocator>;

  explicit SensorModulationPerformance_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->detection_of_measurement_program = 0;
      this->modulation_id = 0;
      this->distance_range_scaling = 0.0f;
      this->separability_distance = 0.0f;
      this->separability_relative_velocity = 0.0f;
      this->precision_distance = 0.0f;
      this->precision_relative_velocity = 0.0f;
      this->covariance_of_distance_and_relative_velocity = 0.0f;
      this->minimum_measurable_distance = 0.0f;
      this->maximum_measurable_distance = 0.0f;
      this->minimum_measurable_relative_velocity = 0.0f;
      this->maximum_measurable_relative_velocity = 0.0f;
    }
  }

  explicit SensorModulationPerformance_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->detection_of_measurement_program = 0;
      this->modulation_id = 0;
      this->distance_range_scaling = 0.0f;
      this->separability_distance = 0.0f;
      this->separability_relative_velocity = 0.0f;
      this->precision_distance = 0.0f;
      this->precision_relative_velocity = 0.0f;
      this->covariance_of_distance_and_relative_velocity = 0.0f;
      this->minimum_measurable_distance = 0.0f;
      this->maximum_measurable_distance = 0.0f;
      this->minimum_measurable_relative_velocity = 0.0f;
      this->maximum_measurable_relative_velocity = 0.0f;
    }
  }

  // field types and members
  using _detection_of_measurement_program_type =
    uint8_t;
  _detection_of_measurement_program_type detection_of_measurement_program;
  using _modulation_id_type =
    uint8_t;
  _modulation_id_type modulation_id;
  using _distance_range_scaling_type =
    float;
  _distance_range_scaling_type distance_range_scaling;
  using _separability_distance_type =
    float;
  _separability_distance_type separability_distance;
  using _separability_relative_velocity_type =
    float;
  _separability_relative_velocity_type separability_relative_velocity;
  using _precision_distance_type =
    float;
  _precision_distance_type precision_distance;
  using _precision_relative_velocity_type =
    float;
  _precision_relative_velocity_type precision_relative_velocity;
  using _covariance_of_distance_and_relative_velocity_type =
    float;
  _covariance_of_distance_and_relative_velocity_type covariance_of_distance_and_relative_velocity;
  using _minimum_measurable_distance_type =
    float;
  _minimum_measurable_distance_type minimum_measurable_distance;
  using _maximum_measurable_distance_type =
    float;
  _maximum_measurable_distance_type maximum_measurable_distance;
  using _minimum_measurable_relative_velocity_type =
    float;
  _minimum_measurable_relative_velocity_type minimum_measurable_relative_velocity;
  using _maximum_measurable_relative_velocity_type =
    float;
  _maximum_measurable_relative_velocity_type maximum_measurable_relative_velocity;

  // setters for named parameter idiom
  Type & set__detection_of_measurement_program(
    const uint8_t & _arg)
  {
    this->detection_of_measurement_program = _arg;
    return *this;
  }
  Type & set__modulation_id(
    const uint8_t & _arg)
  {
    this->modulation_id = _arg;
    return *this;
  }
  Type & set__distance_range_scaling(
    const float & _arg)
  {
    this->distance_range_scaling = _arg;
    return *this;
  }
  Type & set__separability_distance(
    const float & _arg)
  {
    this->separability_distance = _arg;
    return *this;
  }
  Type & set__separability_relative_velocity(
    const float & _arg)
  {
    this->separability_relative_velocity = _arg;
    return *this;
  }
  Type & set__precision_distance(
    const float & _arg)
  {
    this->precision_distance = _arg;
    return *this;
  }
  Type & set__precision_relative_velocity(
    const float & _arg)
  {
    this->precision_relative_velocity = _arg;
    return *this;
  }
  Type & set__covariance_of_distance_and_relative_velocity(
    const float & _arg)
  {
    this->covariance_of_distance_and_relative_velocity = _arg;
    return *this;
  }
  Type & set__minimum_measurable_distance(
    const float & _arg)
  {
    this->minimum_measurable_distance = _arg;
    return *this;
  }
  Type & set__maximum_measurable_distance(
    const float & _arg)
  {
    this->maximum_measurable_distance = _arg;
    return *this;
  }
  Type & set__minimum_measurable_relative_velocity(
    const float & _arg)
  {
    this->minimum_measurable_relative_velocity = _arg;
    return *this;
  }
  Type & set__maximum_measurable_relative_velocity(
    const float & _arg)
  {
    this->maximum_measurable_relative_velocity = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorModulationPerformance
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorModulationPerformance_ & other) const
  {
    if (this->detection_of_measurement_program != other.detection_of_measurement_program) {
      return false;
    }
    if (this->modulation_id != other.modulation_id) {
      return false;
    }
    if (this->distance_range_scaling != other.distance_range_scaling) {
      return false;
    }
    if (this->separability_distance != other.separability_distance) {
      return false;
    }
    if (this->separability_relative_velocity != other.separability_relative_velocity) {
      return false;
    }
    if (this->precision_distance != other.precision_distance) {
      return false;
    }
    if (this->precision_relative_velocity != other.precision_relative_velocity) {
      return false;
    }
    if (this->covariance_of_distance_and_relative_velocity != other.covariance_of_distance_and_relative_velocity) {
      return false;
    }
    if (this->minimum_measurable_distance != other.minimum_measurable_distance) {
      return false;
    }
    if (this->maximum_measurable_distance != other.maximum_measurable_distance) {
      return false;
    }
    if (this->minimum_measurable_relative_velocity != other.minimum_measurable_relative_velocity) {
      return false;
    }
    if (this->maximum_measurable_relative_velocity != other.maximum_measurable_relative_velocity) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorModulationPerformance_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorModulationPerformance_

// alias to use template instance with default allocator
using SensorModulationPerformance =
  off_highway_premium_radar_sample_msgs::msg::SensorModulationPerformance_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_MODULATION_PERFORMANCE__STRUCT_HPP_
