// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_premium_radar_sample_msgs:msg/SensorFeedback.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_FEEDBACK__STRUCT_HPP_
#define OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_FEEDBACK__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'vehicle_time'
#include "off_highway_premium_radar_sample_msgs/msg/detail/time__struct.hpp"
// Member 'measurement_cycle_sync_data'
#include "off_highway_premium_radar_sample_msgs/msg/detail/measurement_cycle_sync_data__struct.hpp"
// Member 'ego_vehicle_data'
#include "off_highway_premium_radar_sample_msgs/msg/detail/ego_vehicle_data__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorFeedback __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorFeedback __declspec(deprecated)
#endif

namespace off_highway_premium_radar_sample_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SensorFeedback_
{
  using Type = SensorFeedback_<ContainerAllocator>;

  explicit SensorFeedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    vehicle_time(_init),
    measurement_cycle_sync_data(_init),
    ego_vehicle_data(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lgp_version = 0ul;
      this->time_sync_status = 0;
    }
  }

  explicit SensorFeedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    vehicle_time(_alloc, _init),
    measurement_cycle_sync_data(_alloc, _init),
    ego_vehicle_data(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->lgp_version = 0ul;
      this->time_sync_status = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _lgp_version_type =
    uint32_t;
  _lgp_version_type lgp_version;
  using _vehicle_time_type =
    off_highway_premium_radar_sample_msgs::msg::Time_<ContainerAllocator>;
  _vehicle_time_type vehicle_time;
  using _measurement_cycle_sync_data_type =
    off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator>;
  _measurement_cycle_sync_data_type measurement_cycle_sync_data;
  using _time_sync_status_type =
    uint8_t;
  _time_sync_status_type time_sync_status;
  using _ego_vehicle_data_type =
    off_highway_premium_radar_sample_msgs::msg::EgoVehicleData_<ContainerAllocator>;
  _ego_vehicle_data_type ego_vehicle_data;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__lgp_version(
    const uint32_t & _arg)
  {
    this->lgp_version = _arg;
    return *this;
  }
  Type & set__vehicle_time(
    const off_highway_premium_radar_sample_msgs::msg::Time_<ContainerAllocator> & _arg)
  {
    this->vehicle_time = _arg;
    return *this;
  }
  Type & set__measurement_cycle_sync_data(
    const off_highway_premium_radar_sample_msgs::msg::MeasurementCycleSyncData_<ContainerAllocator> & _arg)
  {
    this->measurement_cycle_sync_data = _arg;
    return *this;
  }
  Type & set__time_sync_status(
    const uint8_t & _arg)
  {
    this->time_sync_status = _arg;
    return *this;
  }
  Type & set__ego_vehicle_data(
    const off_highway_premium_radar_sample_msgs::msg::EgoVehicleData_<ContainerAllocator> & _arg)
  {
    this->ego_vehicle_data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorFeedback
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_premium_radar_sample_msgs__msg__SensorFeedback
    std::shared_ptr<off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SensorFeedback_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->lgp_version != other.lgp_version) {
      return false;
    }
    if (this->vehicle_time != other.vehicle_time) {
      return false;
    }
    if (this->measurement_cycle_sync_data != other.measurement_cycle_sync_data) {
      return false;
    }
    if (this->time_sync_status != other.time_sync_status) {
      return false;
    }
    if (this->ego_vehicle_data != other.ego_vehicle_data) {
      return false;
    }
    return true;
  }
  bool operator!=(const SensorFeedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SensorFeedback_

// alias to use template instance with default allocator
using SensorFeedback =
  off_highway_premium_radar_sample_msgs::msg::SensorFeedback_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_premium_radar_sample_msgs

#endif  // OFF_HIGHWAY_PREMIUM_RADAR_SAMPLE_MSGS__MSG__DETAIL__SENSOR_FEEDBACK__STRUCT_HPP_
